#include "Entity3dCollection.h"

Entity3dCollection::Entity3dCollection(void)
{
	Clear();
}

void Entity3dCollection::AddEntity(Entity3d ent, int textureIndex)
{
	if(textureIndex >= 0 && textureIndex < TEXTURE_COUNT)
	{
		if(m_entitycount[textureIndex] < MAX_ENTITIES - 1)
		{
			//there is room for another entity
			m_entities[textureIndex][m_entitycount[textureIndex]] = ent;
			m_entitycount[textureIndex]++;
		}
	}
}

Entity3dCollection::~Entity3dCollection(void)
{
}


void Entity3dCollection::Clear()
{
	for(int i = 0; i < TEXTURE_COUNT; i++)
		m_entitycount[i] = 0;
}

void Entity3dCollection::Render(GLuint *textures)
{
	for(int i = 0; i < TEXTURE_COUNT; i++)
	{
		glBindTexture(GL_TEXTURE_2D, textures[i]);

		for(int j = 0; j < m_entitycount[i]; j++)
		{
			m_entities[i][j].Render();
		}
	}
}