#pragma once

#include <utils.h>
#include "BaseRenderable.h"
#include "Entity3dCollection.h"
#include "Vector3d.h"
#include "World.h"

class Renderable3d : public BaseRenderable
{
public:
	Renderable3d(int typeID);
	~Renderable3d(void){}

	virtual void SaveToXml(TiXmlElement *currentElement);
	virtual void LoadFromXml(TiXmlElement *currentElement);

	bool SetWindowSize(int newWindowSize);

	virtual void Initialize(){}
	virtual void Render();
	virtual void Update(bool force);

	//measured in cells
	int m_WindowSizeX, m_WindowSizeY;

protected:

	bool SetSpaceWindow();

	virtual void BuildCollection() = 0;
	WindowMapping m_spaceWindow;

	World* world;

	GLuint m_entityTextures[TEXTURE_COUNT];

	Entity3dCollection m_entityCollection;
};